use std::env;

fn main() {
    let crate_dir = env::var("CARGO_MANIFEST_DIR").unwrap();

    cbindgen::Builder::new()
        .with_crate(crate_dir)
        .with_parse_deps(true)
        .with_parse_include(&["fdo-data-formats"])
        .with_include_version(true)
        .with_include_guard("FDO_DATA_H")
        .with_pragma_once(true)
        .with_autogen_warning("/* This file is automatically generated, do not modify */")
        .with_style(cbindgen::Style::Both)
        .with_item_prefix("Fdo")
        .with_documentation(true)
        .with_language(cbindgen::Language::C)
        .generate()
        .expect("Unable to generate bindings")
        .write_to_file("fdo_data.h");
}
